#include <Grove_LED_Bar.h>
#include "Ultrasonic.h"

#include <SoftwareSerial.h>
#include <MP3Player_KT403A.h>

Ultrasonic ultrasonic_front(2);
Ultrasonic ultrasonic_down(8);


Grove_LED_Bar bar(5, 4, 0);  // Clock pin, Data pin, Orientation

SoftwareSerial mp3(6, 7);

long int soundWaitTime = 120000;
long int front_lastplayed , down_lastplayed;

void setup()
{ 
  Serial.begin(9600);
  // nothing to initialize
  bar.begin();
  bar.setGreenToRed(1);

  mp3.begin(9600);
  delay(100);
    
  SelectPlayerDevice(0x02);       // Select SD card as the player device.
  SetVolume(0x19);                // Set the volume, the range is 0x00 to 0x1E.
  front_lastplayed = -100000;
  down_lastplayed = -20000;
}

void loop()
{
  //update ultrasonic measure
  long front_distance = ultrasonic_front.MeasureInCentimeters();
  long down_distance = ultrasonic_down.MeasureInCentimeters();

  int bar_level = map(down_distance, 0, 42, 10, 0);
  bar_level = constrain(bar_level, 0, 10);
  bar.setLevel(bar_level);
//  Serial.println(bar_level);
  long int currentTime = millis();
  if ( ((currentTime - down_lastplayed)>soundWaitTime) && (currentTime - front_lastplayed)>20000) {
    if ( bar_level > 8 ) {
      SpecifyMusicPlay(3);
      Serial.println("Playing high level track");
      down_lastplayed = currentTime;
    }
  
    if ( (bar_level < 2) && ((currentTime - down_lastplayed)>soundWaitTime) ) {
      SpecifyMusicPlay(2);
      Serial.println("Playing low level track");
      down_lastplayed = currentTime;
    }
  }
  

    if ( (front_distance < 100) && ((currentTime - front_lastplayed)>soundWaitTime) && ((currentTime - down_lastplayed)>20000) ) {
    SpecifyMusicPlay(1);
    Serial.println("Playing proximity track");
    front_lastplayed = currentTime;
  }
  delay(100);
  
  
  long RangeInCentimeters;
  RangeInCentimeters = ultrasonic_front.MeasureInCentimeters(); // two measurements should keep an interval
  Serial.print(RangeInCentimeters);//0~400cm
  Serial.print("  -  ");//0~400cm
  RangeInCentimeters = ultrasonic_down.MeasureInCentimeters(); 
  Serial.print(RangeInCentimeters);//0~400cm
  Serial.println(" cm");

//  if(RangeInCentimeters < 40 ) {
//    SpecifyMusicPlay(1);
//    delay(5000);
//  }
  
}
